.TH DOS 1
.SH NAME
dos \- command line access to Microsoft Windows™ servers
.SH SYNOPSIS
.B dos
[
.B -h
.I host
] [
.B -u
.I user
] [
.B -k
.I keypattern
] [
.B -c
.I cmd args ...
]
.SH DESCRIPTION
.I Dos
connects to a Windows host and starts a session to
.I cmd.exe
on
.IR host ,
or the machine named in the
.B $dos
environment variable if no machine is specified.
.LP
The user name and authentication domain 
is usually picked up from factotum(4), the entry is selected
based on the default domain of the remote host.
An alternative userid may be specified with
.BR -u .
Userids have the form
.B user@authdom
where
.I authdom
is the windows authentication domain.
.PP
If a
.B -c
is present, the remainder of the command line is executed by
.I rc
on the server, and then
.I dos
exits.
.LP
The remote shell's initial working directory is set to the
current directory when
.I dos
was envoked, translated by mappings defined by the
.IR dosmap (6)
configuration files.
.I Rio's
/dev/wdir is kept in sync with directory changes on
the remote server providing (where possible) the correct
context for the plumber.
.LP
On connection the users Roving Profile and user
specific environment are loaded,
vestigial network mounts left over from the GUI environment are
deleted and replaced with shares defined in the configuration files.
.LP
Interrupts and EOF (Ctrl-D) are caught and passed to the remote host
translated to Ctrl-Break and Ctrl-Z respectively.
.LP
If
.I dos(1)
normally relays standard input and output to the remote process,
however if it is envoked with a command only standard output is connected.
.LP
If the session is made to a machine which has network shares, a file
.I $home/lib/dosmap/<hostname>
or, if that doesn't exist 
.I $home/lib/dosmap/<windows-domain-name>
may be used to instruct
.I dos(1)
how to translate remote directory paths
to local ones, and which network shares to
mount when the session is established. 
.LP
These files are formatted with five fields per line, lines may be repeated
if the same remote file server is mounted at multiple different paths on the
local plan9 server. If the first field starts with a hash '#' then the line is
a comment. The fields are:
.br
Drive letter to mount on windows host
.br
Remote fileserver's DNS name, or IP address
.br
Share name and any initial path on the fileserver
.br
Path on the local plan9 host where this is mounted
.SH FILES
c:\\listen\\listen.exe
.br
c:\\listen\\tcp9999.exe
.br
c:\\listen\\dosmap
.br
$home/lib/dosmap/<serverdomain>
.SH SOURCE
.B /sys/src/cmd/dos.c
.br
.B /sys/src/cmd/win32/dosd.c
.br
.B /sys/src/cmd/win32/listen/*
.SH SEE ALSO
.I dosmap (6)
.SH BUGS
The remote shell's standard input, output and error
are attached to the
.I dos
commands file descriptors rather /dev/cons.
.LP
Interrupt and EOF are send using in-band signaling, and to protect this we
use byte stuffing; This is poor design for a TCP link.
.LP
The network link is not encrypted, thus all usernames and passwords
are vunerable to sniffing.
.LP
Detection of the current directory (parsing the windows prompt) is
horrific.
.LP
The
.I Dos
client should be replaced by
.IR cpu (1),
with an additional  
.BR tlspass
authentication mechnism.
.I Dosd.exe
should be replaced by
.I cpud.exe
a 9p client which opens /mnt/term/dev/cons for
console I/O, /mnt/term/dev/cpunote for interrupts, /mnt/term/dev/wdir
to keep the plan9 working directory synchronised with windows directory
changes, and /mnt/term/usr/$user/lib/dosmap to discover shared drive mappings.
